# -*- coding: utf-8 -*-
try:
	from urllib2 import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import json
import re

def log(t):
	try:
		import xbmc
		xbmc.log(t, xbmc.LOGNOTICE)
	except:
		print(t)

def httpget(url):
	return urlopen(url).read()

def live(url):
	import pprint
	log(url)
	url += '&client=iosapp'
	log(url)
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 201'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 202'}
	if 'hls_url' not in data:
		return {'success': False, 'code': 'cntv 203'}
	result = {'success': True, 'title': '', 'url': {}}
	for elem in data['hls_url']:
		url = data['hls_url'][elem]
		o = urlparse(url)
		q = parse_qs(o.query)
		if not o.netloc:
			continue
		if o.path[-5:] != '.m3u8':
			continue
		result['url'][o.netloc + o.path] = url
		log(o.netloc + o.path)
		log(url)
	return result

'''
def live(url):
	import xbmc, pprint
	log(url)
	offset = url.find('pa://cctv_p2p_hd')
	if offset < 0:
		return {'success': False, 'code': 'cntv 200'}
	offset += 16
	channel = url[offset:]
	log(channel)
	if channel[:4] == 'cctv':
		sub = 'cctv'
	else:
		sub = 'wstv'
	log(sub)
	url += '&client=iosapp'
	log(url)
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 201'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 202'}
	if 'hls_url' not in data:
		return {'success': False, 'code': 'cntv 203'}
	#log(pprint.pformat(data['hls_url']))
	url2 = 'http://cbox.cntv.cn/json2015/other/mobileconfig/index.json'
	try:
		content2 = httpget(url2)
	except:
		return {'success': False, 'code': 'cntv 204'}
	try:
		data2 = json.loads(content2)
	except:
		return {'success': False, 'code': 'cntv 205'}
	#log(pprint.pformat(data2))
	if 'data' not in data2:
		return {'success': False, 'code': 'cntv 206'}
	url3 = None
	for elem in data2['data']:
		if elem['title'] == 'encryption_file_url':
			url3 = elem['url']
	if not url3:
		return {'success': False, 'code': 'cntv 207'}
	log(url3)
	try:
		content3 = httpget(url3)
	except:
		return {'success': False, 'code': 'cntv 208'}
	import time
	pos = time.time()
	pos = int(pos)
	pos = ((pos / 86400 ^ 1234509876) + 9876512340) % 4096;
	pos = (pos + 1) % 4096
	log(str(pos))
	mstr = content3[pos * 16 + 16:pos * 16 + 32]
	log(content3[0:16])
	log(mstr.encode('hex'))
	from rijndaelpy import Rijndael
	r = Rijndael('13Abde%6@UdwerPh')
	key = r.decrypt(mstr)
	log(key.encode('hex'))
	r = Rijndael(key)
	var = None
	import base64
	for elem in data['hls_url']:
		url = data['hls_url'][elem]
		log(url)
		t1 = url.split('?')
		t2 = t1[-1]
		log(t2)
		t3 = {}
		for para in t2.split('&'):
			(t4, t5) = para.split('=', 1)
			t3[t4] = t5
		if 'AUTH' in t3 and 'amode' in t3:
			auth = t3['AUTH']
			log(auth)
			log(urlencode({'AUTH': auth}))
			auth = base64.b64decode(auth)
			log(auth.encode('hex'))
			auth = r.encrypt(auth)
			log(auth.encode('hex'))
			auth = base64.b64encode(auth)
			log(auth)
			var = urlencode({'AUTH': content3[0:16] + auth})
			log(urlencode({'AUTH': content3[0:16] + auth}))
			break
	if not var:
		return {'success': False, 'code': 'cntv 209'}
	result = {'success': True, 'item': []}
	result['item'].append({'title': 'kcdnvip-md', 'url': 'http://' + sub + '.hls.cntv.kcdnvip.com/live/' + channel + '/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	result['item'].append({'title': 'qingcdn-md', 'url': 'http://' + sub + '.cntv.qingcdn.com/live/' + channel + '/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	result['item'].append({'title': 'test1', 'url': 'http://' + channel + 'live.cntv.wscdns.com/live/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	result['item'].append({'title': 'test2', 'url': 'http://' + sub + '.cntv.wscdns.com/live/' + channel + '/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	result['item'].append({'title': 'test3', 'url': 'http://' + sub + '.live.cntv.liveplay.myqcloud.com/live/' + channel + '/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	result['item'].append({'title': 'test4', 'url': 'http://' + sub + '.cntv.cdnpe.com/live/' + channel + '/index.m3u8?adapt=0&BR=md&amode=1&' + var})
	return result
		#log(data['hls_url'][elem])
		#log(pprint.pformat(urlparse(data['hls_url'][elem])))
		#log(pprint.pformat(parse_qs(urlparse(data['hls_url'][elem]).query)))
	#result = {'success': True, 'item': []}
	#for item in data['hls_url']:
	#	if data['hls_url'][item][:4] == sub:
	#		if sub == 'wstv':
	#			url = 'http://' + sub + '.cntv.cdnpe.com/cntvlive/' + channel + 'md.m3u8' + data['hls_url'][item][4:]
	#			log(url)
	#			result['item'].append({'title': 'md', 'url': url})
	#		else:
	#			#url = 'http://' + sub + '.cntv.cdnpe.com/cntvlive/' + channel + '.m3u8' + data['hls_url'][item][4:]
	#			#url = 'http://' + sub + '.live.cntv.liveplay.myqcloud.com/live/' + channel + 'hls_/index.m3u8?ptype=1&amode=1&' + data['hls_url'][item][5:]
	#			url = 'http://' + sub + '.cntv.myalicdn.com/cntvlive/' + channel + 'hls_/index.m3u8?ptype=1&amode=1&' + data['hls_url'][item][5:]
	#			#url = 'http://' + sub + '.cntv.myalicdn.com/cntvlive/' + channel + 'hds.f4m?amode=1&AUTH=cntv0005ooefqxwe' + data['hls_url'][item][10:]
	#			log(url)
	#			log(data['hls_url'][item])
	#			try:
	#				content = httpget(url)
	#			except:
	#				return {'success': False, 'code': 'cntv 204'}
	#			for line in content.split('\n'):
	#				line = line.strip()
	#				if not line:
	#					continue
	#				if line[0] == '#':
	#					continue
	#				#result['item'].append({'title': line, 'url': 'http://' + sub + '.cntv.cdnpe.com' + line})
	#				result['item'].append({'title': line, 'url': url.replace(channel + '.m3u8', channal + 'md.m3u8')})
	#				#result['item'].append({'title': line, 'url': 'http://' + sub + '.live.cntv.liveplay.myqcloud.com/' + line})
	#return result
'''

def play(url):
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 100'}
	videoCenterId = re.search('"videoCenterId","(.*?)"', content)
	if videoCenterId == None:
		return {'success': False, 'code': 'cntv 101'}
	videoCenterId = videoCenterId.group(1)
	url = 'http://vdn.apps.cntv.cn/api/getHttpVideoInfo.do?pid=' + videoCenterId
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 102'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 103'}
	try:
		title = data['title']
		chapters = data['video']['chapters']
	except:
		return {'success': False, 'code': 'cntv 104'}
	result = {'success': True, 'title': title, 'url': []}
	for chapter in chapters:
		try:
			result['url'].append(chapter['url'])
		except:
			return {'success': False, 'code': 'cntv 105'}
	return result

def videolist(url):
	o = urlparse(url)
	q = parse_qs(o.query)
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=%s&serviceId=tvcctv&type=0&n=36&p=%s&t=jsonp&cb=Callback' % (q['id'][0], q['p'][0])
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 400'}
	content = re.search('.*?\((.*)\).*?', content, re.DOTALL)
	if content == None:
		return {'success': False, 'code': 'cntv 401'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 402'}
	result = {'success': True, 'item': []}
	for elem in data['response']['docs']:
		result['item'].append({'title': elem['videoTitle'], 'url': elem['videoUrl'], 'folder': False})
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=%s&serviceId=tvcctv&type=0&n=36&p=%d&t=jsonp&cb=Callback' % (q['id'][0], int(q['p'][0]) + 1)
	result['item'].append({'title': 'next', 'url': url, 'folder': True})
	return result

def videoset(url):
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 300'}
	id = re.search('http://api\.cntv\.cn/lanmu/videolistByColumnId\?id=(.*?)&', content, re.DOTALL)
	if id == None:
		return {'success': False, 'code': 'cntv 301'}
	id = id.group(1)
	var = re.search('\s*\'\s*\+\s*(.*?)\s*\+\s*\'\s*', id)
	if var:
		var = var.group(1)
		id = re.search(var + '\s*=\s*\'(.*?)\'', content, re.DOTALL)
		if id == None:
			return {'success': False, 'code': 'cntv 302'}
		id = id.group(1)
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=' + id + '&serviceId=tvcctv&type=0&n=36&p=1&t=jsonp&cb=Callback'
	return videolist(url)
